unit RRPGColorScheme;

interface

uses
  SysUtils, Graphics, Windows, Generics.Collections;

type
  TSituacaoEsquema = (seNormal, seHot, sePressionado, seDisabled);

  TBordaHeader = packed record
    CorExterna: TColor;
    CorInterna: TColor;
  end;

  TCoresHeader = packed record
    Fundo1: TColor;
    Fundo2Cor1: TColor;
    Fundo2Cor2: TColor;
    Bordas: array [0..3] of TBordaHeader;
  end;

  TCoresSituacaoEsquema = record
    Cor1: TColor;
    Cor1End: TColor;
    Cor2: TColor;
    Cor2End: TColor;
    CorBorda: TColor;
    CorBorda2: TColor;
    CorBorda3: TColor;
    CorFonte: TColor;
    CorTracejado: TColor;
    CorNucleo: TColor;
    CorNucleo2: TColor;

    BordasEdit: array [0..3] of TColor; // Cores da borda de um TEdit
    ComboBoxCorSeta: TColor;

    Header: TCoresHeader;
  end;

  PCoresSituacaoEsquema = ^TCoresSituacaoEsquema;

  TArrayCoresEsquema = array [TSituacaoEsquema] of TCoresSituacaoEsquema;

  TTrackBarScheme = record
    CorChannel: TColor;
    CorBordaChannel1: TColor;
    CorBordaChannel2: TColor;
  end;

  THintColor = record
    Cor1: TColor;
    Cor2: TColor;
    CorBorda: TColor;
  end;

  TRoundSel = record
    CorLinhaExterna: TColor;
    CorLinhaInterna: TColor;
    CorNucleo1: TColor;
    CorNucleo2: TColor;
  end;

  TEsquema = record
    Cores: TArrayCoresEsquema;
    CorFundoTabSelecionado: TColor;
    CorFundoPageControl: TColor;

    CorTextoNormal: TColor;
    CorTextoTitulo: TColor;
    CorTextoInformacao: TColor;
    CorTextoAlerta: TColor;
    CorWindow: TColor;
    CorHeaderPanel: TColor;
    CorHeaderPanel2: TColor;
    CorBordaPanel: TColor;

    CorLink: TColor;
    CorLinkHot: TColor;
    CorLinkDef: TColor;
    CorLinkDefHot: TColor;

    TrackBar: TTrackBarScheme;
    HintColor: THintColor;
    RoundSel: TRoundSel;

    CorBarraProgresso: TColor;
    CorSearchIcon: TColor;
    CorHotMouse: TColor;
    CorLinhaTituloLVW: TColor;
    CorLinhaShadowDockPainter: TColor;
    CorLinhaShadowDockPainter2: TColor;
    CorLinhaShadowDockPainter3: TColor;
    CorLinhaShadowDockPainter4: TColor;
    CorLinhaShadowDockPainter5: TColor;
    CorBGDockTabSet: TColor;
    CorWindowFrame: TColor;
    CorSkyBlue: TColor;
  end;

const
  EsquemaPadrao: TEsquema = (
      // Cores
      Cores: (
        // Normal
        (Cor1: $F2F2F2;
         Cor1End: $EBEBEB;
         Cor2: $DDDDDD;
         Cor2End: $D0D0D0;
         CorBorda: $707070;
         CorBorda2: $FCFCFC;
         CorBorda3: $B9B3AE;
         CorFonte: clWindowText;
         CorTracejado: $0A1026;
         CorNucleo: $945C47;
         CorNucleo2: $C7820B;
         BordasEdit: ($B3ADAB, $E6DFDB, $EFE9E3, $EAE3E2);
         ComboBoxCorSeta: clBlack;

         Header: (
           Fundo1: clWhite;
           Fundo2Cor1: $FAF8F7;
           Fundo2Cor2: $F4F2F1;

           Bordas: (
              (CorExterna: clWhite; CorInterna: clWhite), // Top
              (CorExterna: $F2F2F2; CorInterna: clWhite), // Right e Left-Top
              (CorExterna: $E7E6E5; CorInterna: $FDFDFC), // Right e Left-Bottom
              (CorExterna: $D5D5D5; CorInterna: $D5D5D5)  // Bottom
                 ))

                 ),

        // Hot
        (Cor1: $FDF6EA;
         Cor1End: $FCF0D9;
         Cor2: $FDE6BE;
         Cor2End: $F5D9A7;
         CorBorda: $B17F3C;
         CorBorda2: $FEFBF5;
         CorBorda3: $F9C679;
         CorFonte: clWindowText;
         CorTracejado: $0A1026;
         CorNucleo: $712204;
         CorNucleo2: $F3A00D;
         BordasEdit: ($BF9457, $EAD5B7, $F1E2C7, $EDDAC5);
         ComboBoxCorSeta: clBlack;

         Header: (
           Fundo1: $FFF7E3;
           Fundo2Cor1: $FFEDBD;
           Fundo2Cor2: $FBE7B7;

           Bordas: (
              (CorExterna: clWhite; CorInterna: clWhite), // Top
              (CorExterna: $EBCB88; CorInterna: $FFF7E3), // Right e Left-Top
              (CorExterna: $E3BB69; CorInterna: $FEEBBB), // Right e Left-Bottom
              (CorExterna: $E3C993; CorInterna: $FBE7B7)  // Bottom
                 ))
         ),

        // Pressionado
        (Cor1: $FCF4E5;
         Cor1End: $F6E5C4;
         Cor2: $EFD198;
         Cor2End: $DDB66D;
         CorBorda: $8B622C;
         CorBorda2: $CBBA9A;
         CorBorda3: $F7B65E;
         CorFonte: clWindowText;
         CorTracejado: $0A1026;
         CorNucleo: $985936;
         CorNucleo2: $835407;
         BordasEdit: ($AD7B3D, $E3C9A4, $EDD9B7, $E7CFB5);
         ComboBoxCorSeta: clBlack;

         Header: (
           Fundo1: $F9E4BC;
           Fundo2Cor1: $F7D68D;
           Fundo2Cor2: $F5D18A;

           Bordas: (
              (CorExterna: $B2A386; CorInterna: $E1CEAA), // Top
              (CorExterna: $B19E7A; CorInterna: $E0CBA2), // Right e Left-Top
              (CorExterna: $AE8F4F; CorInterna: $DEBC6F), // Right e Left-Bottom
              (CorExterna: $E3C993; CorInterna: $F5D18A)  // Bottom
                 ))
         ),

        // Desativado
        (Cor1: $F4F4F4;
         Cor1End: $F4F4F4;
         Cor2: $F4F4F4;
         Cor2End: $F4F4F4;
         CorBorda: $B5B2AD;
         CorBorda2: $FCFCFC;
         CorBorda3: $FCFCFC;
         CorFonte: clInactiveCaptionText;
         CorTracejado: $0A1026;
         CorNucleo: $BFBFBF;
         CorNucleo2: $B4B4B4;
         BordasEdit: ($AFAFAF, $AFAFAF, $AFAFAF, $AFAFAF);
         ComboBoxCorSeta: clBlack));

    CorFundoTabSelecionado: clWhite;
    CorFundoPageControl: clWhite;
    CorTextoNormal: clBlack;
    CorTextoTitulo: $993300;
    CorTextoInformacao: $6D6D6D;
    CorTextoAlerta: $0000FF;
    CorWindow: clWhite;
    CorHeaderPanel: clWhite;
    CorHeaderPanel2: $00E6F8FF;
    CorBordaPanel: clSilver;
    CorLink: $CC6600;
    CorLinkHot: $FF9933;
    CorLinkDef: $008000;
    CorLinkDefHot: $008000;

    TrackBar: (
      CorChannel: $EAEAE7;
      CorBordaChannel1: $B0B0B0;
      CorBordaChannel2: $FCFCFC);

    HintColor: (
      Cor1: clWhite;
      Cor2: $F0E5E4;
      CorBorda: $767676);

    RoundSel: (CorLinhaExterna: $fcd7b9;
               CorLinhaInterna: $fffbf8;
               CorNucleo1: $fffdfc;
               CorNucleo2: $fff5ed);

    CorBarraProgresso: clGreen;
    CorSearchIcon: $696969;
    CorHotMouse: $EFD3C6;
    CorLinhaTituloLVW: $e0c1b2;
    CorLinhaShadowDockPainter: $00C0C0C0;
    CorLinhaShadowDockPainter2: $00202020;
    CorLinhaShadowDockPainter3: $606060;
    CorLinhaShadowDockPainter4: $DDDDDD;
    CorLinhaShadowDockPainter5: $A0A0A0;
    CorBGDockTabSet: $F0F0F0;
    CorWindowFrame: $646464;
    CorSkyBlue: $00F0CAA6;
       );

type
  TNotifyScheme = procedure of object;

var
  EsquemaAtual: TEsquema;
  EsquemaNegro: TEsquema;

function CorInversa(C: TColor): TColor;

procedure RegistrarNotScheme(Obj: TObject; Evento: TNotifyScheme);
procedure DesregistrarNotScheme(Obj: TObject);
procedure NotificarAlteracaoScheme;
function SegoeFontName: String;

implementation

uses
  RRPGUtil;

var
  NotList: TDictionary<TObject,TNotifyScheme>;

function SegoeFontName: String;
begin
  Result := 'Tahoma';
end;

procedure RegistrarNotScheme(Obj: TObject; Evento: TNotifyScheme);
begin
  if NotList = nil then
    NotList := TDictionary<TObject,TNotifyScheme>.Create;

  NotList.AddOrSetValue(Obj, Evento);
end;

procedure DesregistrarNotScheme(Obj: TObject);
begin
  if NotList = nil then
    Exit;

  NotList.Remove(Obj);
end;

procedure NotificarAlteracaoScheme;
var
  E: TDictionary<TObject,TNotifyScheme>.TPairEnumerator;
begin
  if NotList = nil then
    Exit;

  E := NotList.GetEnumerator;

  try
    while E.MoveNext() do
      E.Current.Value();
  finally
    E.Free;
  end;
end;

function CorInversa(C: TColor): TColor;
var
  R, G, B: Integer;
begin
  C := ColorToRGB(C);
  R := GetRValue(C);
  G := GetGValue(C);
  B := GetBValue(C);

  R := 255 - R;
  G := 255 - G;
  B := 255 - B;

  Result := RGB(R, G, B);
end;

procedure InverterEsquema(var Esq: TEsquema);
var
  T: TSituacaoEsquema;
  i: Integer;

  function Inverso(C: TColor): TColor;
  begin
    Result := CorInversa(C);
  end;
begin
  with Esq do
  begin
    CorFundoTabSelecionado := Inverso(CorFundoTabSelecionado);
    CorFundoPageControl := Inverso(CorFundoPageControl);
    CorTextoNormal := Inverso(CorTextoNormal);
    CorTextoTitulo := Inverso(CorTextoTitulo);
    CorTextoInformacao := Inverso(CorTextoInformacao);
    CorWindow := Inverso(CorWindow);
    CorHeaderPanel := Inverso(CorHeaderPanel);
    CorHeaderPanel2 := $09081c;
    CorLink := Inverso(CorLink);
    CorLinkHot := Inverso(CorLinkHot);

    CorLinkDef := $7FFF7F;
    CorLinkDefHot := CorLinkDef;
    //CorLinkDef := Inverso(CorLinkDef);
    //CorLinkDefHot := Inverso(CorLinkDefHot);

    CorBordaPanel := Inverso(CorBordaPanel);
    CorSearchIcon := Inverso(CorSearchIcon);
    CorHotMouse := Inverso(CorHotMouse);
    CorLinhaTituloLVW := Inverso(CorLinhaTituloLVW);
    CorLinhaShadowDockPainter := Inverso(CorLinhaShadowDockPainter);
    CorLinhaShadowDockPainter2 := Inverso(CorLinhaShadowDockPainter2);
    CorLinhaShadowDockPainter3 := Inverso(CorLinhaShadowDockPainter3);
    CorLinhaShadowDockPainter4 := Inverso(CorLinhaShadowDockPainter4);
    CorLinhaShadowDockPainter5 := Inverso(CorLinhaShadowDockPainter5);
    CorBGDockTabSet := Inverso(CorBGDockTabSet);
    CorWindowFrame:= Inverso(CorWindowFrame);
    CorSkyBlue := Inverso(CorSkyBlue);

    CorBarraProgresso := CorLinkDef; // Nao inverter esta cor

    with RoundSel do
    begin
      CorLinhaExterna := Inverso(CorLinhaExterna);
      CorLinhaInterna := Inverso(CorLinhaInterna);
      CorNucleo1 := Inverso(CorNucleo1);
      CorNucleo2 := Inverso(CorNucleo2);
    end;

    with TrackBar do
    begin
      CorChannel := Inverso(CorChannel);
      CorBordaChannel1 := Inverso(CorBordaChannel1);
      CorBordaChannel2 := Inverso(CorBordaChannel2);
    end;

    with HintColor do
    begin
      Cor1 := Inverso(Cor1);
      Cor2 := Inverso(Cor2);
      CorBorda := Inverso(CorBorda);
    end;
  end;

  for T := Low(TSituacaoEsquema) to High(TSituacaoEsquema) do
    with Esq.Cores[T] do
    begin
      Cor1 := Inverso(Cor1);
      Cor1End := Inverso(Cor1End);
      Cor2 := Inverso(Cor2);
      Cor2End := Inverso(Cor2End);
      CorBorda := Inverso(CorBorda);
      CorBorda2 := Inverso(CorBorda2);
      CorBorda3 := Inverso(CorBorda3);
      CorFonte := Inverso(CorFonte);
      CorNucleo := Inverso(CorNucleo);
      CorNucleo2 := Inverso(CorNucleo2);
      CorTracejado := Inverso(CorTracejado);
      ComboBoxCorSeta := Inverso(ComboBoxCorSeta);

      for i := 0 to Length(BordasEdit) - 1 do
        BordasEdit[i] := Inverso(BordasEdit[i]);

      Header.Fundo1 := Inverso(Header.Fundo1);
      Header.Fundo2Cor1 := Inverso(Header.Fundo2Cor1);
      Header.Fundo2Cor2 := Inverso(Header.Fundo2Cor2);

      for i := 0 to Length(Header.Bordas) - 1 do
        with Header.Bordas[i] do
        begin
          CorExterna := Inverso(CorExterna);
          CorInterna := Inverso(CorInterna);
        end;
    end;
end;

initialization
  EsquemaNegro := EsquemaPadrao;
  InverterEsquema(EsquemaNegro);

  EsquemaAtual := EsquemaPadrao;
//  EsquemaAtual := EsquemaNegro;

finalization
  if NotList <> nil then
    FreeAndNil(NotList);

end.
