unit RRPGDockTabSet;

interface

uses
  Windows, SysUtils, DockTabSet, RRPGDockTree, Controls, Classes, Graphics;

type
  TRDockTabSet = class(TDockTabSet)
  protected
    procedure ConfigurarVisual; virtual;
    procedure Loaded; override;
    procedure DrawTab(TabCanvas: TCanvas; R: TRect; Index: Integer;
      Selected: Boolean); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  end;

implementation

uses
  RRPGColorScheme, ComCtrls, Tabs, RRPGDrawUtil, Types, Math;

{ TRDockTabSet }

procedure TRDockTabSet.ConfigurarVisual;
begin
  Self.BackgroundColor := EsquemaAtual.CorBGDockTabSet;
  Self.UnselectedColor := EsquemaAtual.CorWindow;
  Self.SelectedColor := EsquemaAtual.CorBGDockTabSet;
  Self.Font.Color := EsquemaAtual.CorTextoNormal;
end;

constructor TRDockTabSet.Create(AOwner: TComponent);
begin
  inherited;
  RegistrarNotScheme(Self, Self.ConfigurarVisual);

  if Self.HandleAllocated then
    Self.ConfigurarVisual;
end;

destructor TRDockTabSet.Destroy;
begin
  DesregistrarNotScheme(Self);
  inherited;
end;

procedure TRDockTabSet.DrawTab(TabCanvas: TCanvas; R: TRect; Index: Integer;
  Selected: Boolean);
begin
  inherited;

end;

procedure TRDockTabSet.Loaded;
begin
  inherited;
  Self.ConfigurarVisual;
end;

end.
