unit RRPGPaintBox;

interface

uses
  Messages, Windows, SysUtils, Classes, Controls, ExtCtrls, Graphics;

type
  TRPaintBox = class(TCustomControl)
  private
    FOnPaint: TNotifyEvent;
    FOnEraseBackground: TNotifyEvent;
  protected
    procedure WMEraseBkgnd(var Message: TWMEraseBkgnd); message WM_ERASEBKGND;
    procedure Paint; override;
  public
    property Canvas;
  published
    property OnExit;
    property OnEnter;
    property TabStop;
    property OnKeyUp;
    property OnKeyPress;
    property OnKeyDown;
    property OnMouseWheelUp;
    property OnMouseWheelDown;
    property OnMouseWheel;
    property OnMouseLeave;
    property OnMouseEnter;
    property OnMouseMove;
    property OnMouseUp;
    property OnMouseDown;
    property OnStartDock;
    property OnStartDrag;
    property Align;
    property Anchors;
    property Color;
    property Constraints;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Font;
    property ParentColor;
    property ParentFont;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property Touch;
    property Visible;
    property OnClick;
    property OnContextPopup;
    property OnDblClick;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnGesture;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    property OnEraseBackground: TNotifyEvent read FOnEraseBackground write FOnEraseBackground;
  end;

implementation

{ TRPaintBox }

procedure TRPaintBox.Paint;
begin
  inherited;
  Canvas.Font := Font;
  Canvas.Brush.Color := Color;

  if csDesigning in ComponentState then
    with Canvas do
    begin
      Pen.Style := psDash;
      Brush.Style := bsClear;
      Rectangle(0, 0, Width, Height);
    end;

  if Assigned(FOnPaint) then
    FOnPaint(Self);
end;

procedure TRPaintBox.WMEraseBkgnd(var Message: TWMEraseBkgnd);
begin
  if not( csDesigning in Self.ComponentState) then
  begin
    Message.Result := 1;

    if csLoading in Self.ComponentState then
      Exit;

    if Assigned(FOnEraseBackground) then
    begin
      Self.Canvas.Handle := Message.DC;

      try
        FOnEraseBackground(Self)
      finally
        Self.Canvas.Handle := 0;
      end;
    end;
  end else
    inherited;
end;

end.
